from __future__ import print_function
# V8 : distance a la camera
# V6 : pas de fichier
# CREE LES FICHIERS 
#vertices: str(V.co[0])+','+str(V.co[1])+','+str(V.co[2])+';'
# ET positions_camera : str(frame).zfill(5)+';'+str(loc[0])+','+str(loc[1])+','+str(loc[2])+';'+str(Inverse.item((i,j)))+','
# puis bpy.ops.script.python_file_run(filepath='CreeuneImage01.py')
import bpy,math,os

debug=False#debug=True4
scene=bpy.data.scenes['Scene']





frame_init,frame_finale,frame_pas=0,250,1

obj=scene.objects['lens03ply']#obj=scene.objects['Cube']obj=scene.objects['Maison']

path='images'
if not os.path.exists(path):
	os.mkdir(path)
template=path+'/maison-'

camera=bpy.data.objects['Camera.001']
camera.rotation_mode='XYZ'


#_ImageDeBase='statue100x100.png'#_ImageDeBase='statue512x512.png'#_ImageDeBase='statue1024x1024.png'
_ImageDeBase='maison.png'

Zmin,Zmax=0.0,3.1#Zmin,Zmax=0.0,2.5

TailleDelaSortie=[1280,1080]

if _ImageDeBase not in bpy.data.images or bpy.data.images[_ImageDeBase].size!=TailleDelaSortie:
	bpy.ops.image.new(name=_ImageDeBase,width=TailleDelaSortie[0], height=TailleDelaSortie[1],color=(0, 0, 0, 1),alpha=True, generated_type='BLANK', float=False, gen_context='NONE')
	image=bpy.data.images[_ImageDeBase]
	image.filepath=_ImageDeBase
	image.save()
image=bpy.data.images[_ImageDeBase]
Larg,Haut=image.size[0],image.size[1]#100,100#1024,1024


##################################LA LENTILLE :
cx=Larg/2.0#512.0
cy=Haut/2.0#512.0
fx=8664.109/10.0#/1.1
fy=8669.999/10.0#/1.1
print('cx,cy,fx,fy : ',cx,cy,fx,fy)


"""

if os.path.isfile(_ImageDeBase):
	image=sf.Image.from_file(_ImageDeBase)
else:
	image = sf.Image.create(512, 512, sf.Color.BLACK)
print('rrrrrr',image.size)	
"""






import numpy
from numpy  import matrix,pi,cos,sin
import time
t=time.time()
temps_initial=t
import re



print('	temps estimee TOTAL :',0.08/52000*len(obj.data.vertices) + 0.1/251*(frame_finale-frame_init+1) + 0.27/6*(frame_finale-frame_init+1) + (frame_finale-frame_init+1)*17.5*(len(obj.data.vertices)/120000)*(Larg/1280.0)*(Haut/1080.0))

#######0.8/52000 s/vert
print('##############################################################')
print('VERTICES')

print('	temps estimee:',0.08/52000*len(obj.data.vertices))
_PLY=[]#f=open('vertices','w')
#print(obj.name+':x,y,z,',file=f)
for V in obj.data.vertices:
	#ligne=str(V.co[0])+','+str(V.co[1])+','+str(V.co[2])+';'
	_PLY.append(V.co)#print(ligne,file=f)
#f.close()
print('   temps VERTICES',time.time()-t)

import shutil

def copyFile(src, dest):
	try:
		shutil.copy(src, dest)
	# eg. src and dest are the same file
	except shutil.Error as e:
		print('Error: %s' % e)
	# eg. source or destination doesn't exist
	except IOError as e:
		print('Error: %s' % e.strerror)
		
		
def Hprint(s):
	print(s)




print('##############################################################')
print('CAMERA')
_CAMERA=[]
action=camera.animation_data.action # bpy.data.actions['Camera.001Action']
i,tmp,courbes=0,'',['' for i in range(6)]
while i<=5:
	#courbes[i]=action.groups['LocRot'].channels[i] # 
	courbes[i]=action.fcurves[i]
	i+=1
print('	temps estimee:',0.1/251*(frame_finale-frame_init))
t=time.time()
#f=open('positions_camera','w')
_Euler_tmp=camera.rotation_euler
for frame in range(frame_init,frame_finale+1,frame_pas):
	scene.frame_current=frame
	loc=[courbes[i].evaluate(frame) for i in range(3)]#camera.location
	#Hprint(loc) 
	#camera.rotation_euler=
	_Euler_tmp[0],_Euler_tmp[1],_Euler_tmp[2] = courbes[3].evaluate(frame),courbes[4].evaluate(frame),courbes[5].evaluate(frame)
	Inverse=matrix(_Euler_tmp.to_matrix()).getI()
	_CAMERA.append([frame,loc,Inverse])#print(str(frame).zfill(5)+';'+ligne,file=f) 
print('	 temps CAMERA',time.time()-t)	
# PLY contient [X,Y,Z] 
#	 


# COPIE : CREE 'images/statue-'+str(frame).zfill(5)+'.png'	
print('##############################################################')
t=time.time()	
print('COPY IMAGES')
print('	temps estimee max:',0.27/6*(frame_finale-frame_init))
for frame in range(frame_init,frame_finale+1,frame_pas):	
	fich=template+str(frame).zfill(5)+'.png'
	"""
	if not os.path.isfile(fich):
		copyFile(_ImageDeBase,fich )
	"""
	copyFile(_ImageDeBase,fich )
print('	temps COPY',time.time()-t)   
	

print('##############################################################')
print('CreeuneImage01.py')
#bpy.ops.script.python_file_run(filepath='CreeuneImage01.py')


Vertices=[]#[matrix]


def LENS(X,Y,Z):
	xp=X/Z
	yp=Y/Z
	u = cx + xp*fx
	v = cy + yp*fy
	return u,v




"""
print('_CAMERA[0:6])',_CAMERA[0:6])
[[0, Vector((-0.6537628173828125, 2.768256187438965, 2.9293644428253174)), matrix([[ -8.43405910e-01,  -5.37276861e-01,  -8.21444227e-09],
		[  4.23704866e-01,  -6.65123019e-01,   6.14886638e-01],
		[ -3.30364358e-01,   5.18599047e-01,   7.88615492e-01]])],...
"""

debug=False#True
PIXELS=[]
for i in _CAMERA[0:frame_finale-frame_init+1]:
	t=time.time()
	print('  IMAGE :'+str(i[0])+': temps estimee de l image: ',17.5*(len(_PLY)/120000)*(Larg/1280.0)*(Haut/1080.0))
	points=[]
	points_tmp=[]
	image=''
	#t=time.time()
   
	frame=i[0]
	CAM=matrix([  [i[1][0]],[i[1][1]],[i[1][2]]  ])
	Inverse=i[2]
	####### creation d une image

	BB=Inverse*(-CAM)
	for point in _PLY:
		#print(point)        	
		M=matrix([  [point[0]],[point[1]],[point[2]]  ])		 
		r=Inverse*M+BB#r=Inverse*(M-CAM)#la camera est en 0,0,0 dirigee vers le bas
		X,Y,Z=float(r[0]),float(r[1]),float(r[2])
		if Z < 0: 
			x,y=LENS(X,Y,-Z)
			x,y=int(x+0.5),int(y+0.5)
			#print('x,y,X,Y,-Z',x,y,X,Y,-Z)
			if x>=0 and y>=0 and x<Larg and y<Haut:
				c0 = int( (1.0*point[2]-Zmin)/(Zmax-Zmin) *100.0 )/100.0
				c0=min(1.0,max(c0,0.0))
				if debug==True:
					print(point[2],(1.0*point[2]-Zmin)/(Zmax-Zmin) *100.0,c0)
				c2 = 1.0-c0
				#print( (M-CAM),(M-CAM).getT() )
				#print( (M-CAM)*(M-CAM).getT() )
				distance=float( (M-CAM).getT() * (M-CAM))
				points.append([x,y,c0,c2,distance])
	#print(distance)	
	#B=sorted( sorted( sorted(A, key=lambda tabl: tabl[2]) , key=lambda tabl: tabl[1] ) , key=lambda tabl: tabl[0] ) 
	points=sorted( sorted(points, key=lambda tabl: tabl[1]) , key=lambda tabl: tabl[0] )	
	#print(points)	
	print('	 on obtient '+str(len(	points))+' points dans le cadre sur '+str(len(_PLY))+' points du ply')	
	image=bpy.data.images[_ImageDeBase]
	image.filepath=template+str(frame).zfill(5)+'.png'
	print('	  '+image.filepath)
	
	
	pointCourant=[-1,-1]
	PIXELS=[0.0,0.0,0.0,1.0] * (Larg*Haut)
	DistTmp=1.0E9
	for point in points:#[x,y,c0,c2]
		#print(point)
		
		if [point[0],point[1]] != pointCourant:
			n=4*(point[0]+point[1]*Larg)
			PIXELS[n+0]=point[2] #image.pixels[n*4+0]=point[2]
			PIXELS[n+2]=point[3] #image.pixels[n*4+2]=point[3]
			pointCourant=[point[0],point[1]]
			DistTmp=1.0E9
		else:
			if distance < DistTmp:
				n=4*(point[0]+point[1]*Larg)
				PIXELS[n+0]=point[2] #image.pixels[n*4+0]=point[2]
				PIXELS[n+2]=point[3] #image.pixels[n*4+2]=point[3]
				#pointCourant=[point[0],point[1]]
				DistTmp = distance 
			
	"""
	for i in range(1000):		
		image.pixels[i]=1.0
	"""
	#print(len(image.pixels))
	#print(PIXELS[n:n+10])
	image.pixels=PIXELS
	image.save()
	print('      temps de l image: ',time.time()-t)
  
print('fini')  
#print(_PLY)	


'''
>>> courbe=action.groups['LocRot'].channels[0] # bpy.data.actions['Camera.001Action']...FCurve
action=camera.animation_data.action # bpy.data.actions['Camera.001Action']



'''
print('temps total :',time.time()-temps_initial)
